#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define int long long
#define double long double

using namespace std;

struct node1{
    int a, ind, sum;
};

struct node2{
    vector<node1> vec;
    int sum;
    int ind;
};

bool comp1(node1 a, node1 b){
    return a.sum < b.sum;
}

bool comp2(node2 a, node2 b){
    return a.sum < b.sum;
}

signed main() {
    int h, w;
    cin >> h >> w;
    vector<vector<int>> a(h, vector<int> (w));
    int sum = 0;
    vector<int> sy (w);
    for (int i = 0; i < h; i++){
        for (int j = 0; j < w; j++){
            cin >> a[i][j];
            sum += a[i][j];
            sy[j] += a[i][j];
        }
    }
    int s;
    cin >> s;
    vector<node2> b (h);
    for (int i = 0; i < h; i++){
        node2 x;
        int sx = 0;
        for (int j = 0; j < w; j++){
            node1 y;
            y.a = a[i][j];
            y.ind = j;
            y.sum = sy[j];
            x.vec.push_back(y);
            sx += a[i][j];
        }
        x.sum = sx;
        x.ind = i;
        b[i] = x;
    }
    for (int i = 0; i < h; i++){
        sort(b[i].vec.begin(), b[i].vec.end(), comp1);
    }
    sort(b.begin(), b.end(), comp2);
    vector<vector<int>> dp(h + 1, vector<int> (w + 1));
    dp[0][0] = sum;
    for (int i = 0; i <= h; i++){
        for (int j = 0; j <= w; j++){
            if (i){
                dp[i][j] = dp[i - 1][j] - b[i - 1].sum;
                for (int k = 0; k < j; k++) {
                    dp[i][j] += b[i - 1].vec[k].a;
                }
            }
            else if (j){
                dp[i][j] = dp[i][j - 1] - sy[j - 1];
                for (int k = 0; k < i; k++){
                    dp[i][j] += b[k].vec[j - 1].a;
                }
            }
            if (dp[i][j] == s){
                cout << "YES\n";
                for (int k = 0; k < i; k++){
                    cout << 1 << ' ' << b[k].ind << endl;
                }
                for (int k = 0; k < j; k++){
                    cout << 2 << ' ' << b[0].vec[k].ind << endl;
                }
                return 0;
            }
        }
    }
    cout << "NO";
}