#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define int long long
#define double long double

using namespace std;

void dfs(int v, vector<vector<int>>& g, vector<bool>& vis, vector<bool>& a){
    vis[v] = true;
    for (auto to : g[v]){
        if (!vis[to]){
            a[to] = !a[v];
            dfs(to, g, vis, a);
        }
    }
}

signed main() {
    int n;
    cin >> n;
    vector<bool> a(1e6 + 1, false), p(1e6 + 1, true), used(1e6 + 1);
    p[1] = false;
    for (int i = 2; i <= 1e6; i++) {
        if (p[i]) {
            for (int j = i * 2; j <= 1e6; j += i) {
                p[j] = false;
            }
        }
    }
    vector<int> c(n);
    vector<vector<int>> g(1e6 + 1);
    for (int i = 0; i < n; i++){
        cin >> c[i];
    }
    vector<int> b = c;
    sort(b.begin(), b.end());
    vector<int> d = {b[0]};
    used[b[0]] = true;
    for (int i = 1; i < n; i++){
        if (b[i] != d.back()){
            d.push_back(b[i]);
            used[b[i]] = true;
        }
    }
    for (int i = 0; i < d.size(); i++){
        int v = d[i];
        for (int j = i; j >= 0 && d[j] * d[j] >= v; j--){
            if (v % d[j] == 0 && p[v / d[j]]){
                g[v].push_back(d[j]);
                g[d[j]].push_back(v);
            }
            if (v % d[j] == 0 && p[d[j]] && used[v / d[j]] && d[j] * d[j] != v){
                g[v].push_back(v / d[j]);
                g[v / d[j]].push_back(v);
            }
        }
    }
    vector<bool> vis(1e6 + 1, false);
    for (int i = 1; i <= 1e6; i++){
        if (!vis[i]){
            dfs(i, g, vis, a);
        }
    }
    for (auto i : c){
        if (a[i]){
            cout << 2;
        }
        else{
            cout << 1;
        }
        cout << ' ';
    }
}