#include <iostream>
#include <vector>

#define int long long
#define double long double

using namespace std;

signed main() {
    int n;
    cin >> n;
    vector<bool> a(1e6 + 1, false), p(1e6 + 1, true), used(1e6 + 1, false);
    p[1] = false;
    for (int i = 2; i <= 1e6; i++){
        if (p[i]){
            for (int j = i * 2; j <= 1e6; j += i){
                p[j] = false;
            }
        }
    }
    for (int i = 0; i < n; i++){
        int x;
        cin >> x;
        if (used[x]){
            if (a[x]){
                cout << 1;
            }
            else {
                cout << 2;
            }
            cout << ' ';
            continue;
        }
        for (int j = 1; j * j <= x; j++){
            if (x % j == 0 && p[x / j]){
                if (used[j]){
                    a[x] = !a[j];
                    break;
                }
            }
        }
        used[x] = true;
        if (a[x]){
            cout << 1;
        }
        else{
            cout << 2;
        }
        cout << ' ';
    }
}
