#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define int long long
#define double long double

using namespace std;

pair<set<int>, set<int>> f(vector<vector<int>>& a, pair<set<int>, set<int>>& b, map<pair<set<int>, set<int>>, int>& dp, int s){
    vector<int> x, y;
    auto b1 = b;
    while(!b1.first.empty()){
        x.push_back(*b1.first.begin());
        b1.first.erase(*b1.first.begin());
    }
    while(!b1.second.empty()){
        y.push_back(*b1.second.begin());
        b1.second.erase(*b1.second.begin());
    }
    int sum = 0;
    for (int i = 0; i < a.size(); i++){
        bool t = false;
        for (int j = 0; j < x.size(); j++){
            if (i == x[j]){
                t = true;
                break;
            }
        }
        if (t){
            continue;
        }
        for (int j = 0; j < a[0].size(); j++){
            for (int k = 0; k < y.size(); k++){
                if (j == y[k]){
                    t = true;
                    break;
                }
            }
            if (t){
                continue;
            }
            sum += a[i][j];
        }
    }
    dp[b] = sum;
    if (sum == 0){
        dp[b] = -1;
    }
    if (sum == s){
        return b;
    }
    for (int i = 0; i < a.size(); i++){
        bool t = false;
        for (int j = 0; j < x.size(); j++){
            if (i == x[j]){
                t = true;
                break;
            }
        }
        if (t){
            continue;
        }
        auto c = b;
        c.first.insert(i);
        if (dp[c] == 0){
            auto r = f(a, c, dp, s);
            if (*r.first.begin() != -1){
                return r;
            }
        }
    }
    for (int i = 0; i < a[0].size(); i++){
        bool t = false;
        for (int j = 0; j < y.size(); j++){
            if (i == y[j]){
                t = true;
                break;
            }
        }
        if (t){
            continue;
        }
        auto c = b;
        c.second.insert(i);
        if (dp[c] == 0){
            auto r = f(a, c, dp, s);
            if (*r.first.begin() != -1){
                return r;
            }
        }
    }
    set<int> r;
    r.insert(-1);
    return {r, r};
}

signed main() {
    int h, w;
    cin >> h >> w;
    vector<vector<int>> a(h, vector<int> (w));
    int sum = 0;
    for (int i = 0; i < h; i++){
        for (int j = 0; j < w; j++){
            cin >> a[i][j];
            sum += a[i][j];
        }
    }
    int s;
    cin >> s;
    map<pair<set<int>, set<int>>, int> dp;
    set<int> start;
    dp[{start, start}] = sum;
    if (sum == 0){
        dp[{start, start}] = -1;
    }
    pair<set<int>, set<int>> b = {start, start};
    auto r = f(a, b, dp, s);
    if (*r.first.begin() == -1){
        cout << "NO";
        return 0;
    }
    cout << "YES\n";
    vector<int> x, y;
    while(!r.first.empty()){
        x.push_back(*r.first.begin());
        r.first.erase(*r.first.begin());
    }
    while(!r.second.empty()) {
        y.push_back(*r.second.begin());
        r.second.erase(*r.second.begin());
    }
    for (int i = 0; i < x.size(); i++){
        cout << 1 << ' ' << x[i] + 1 << endl;
    }
    for (int i = 0; i < y.size(); i++){
        cout << 2 << ' ' << y[i] + 1 << endl;
    }
}
