#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define int long long
#define double long double

using namespace std;

pair<set<int>, set<int>> f(vector<vector<int>>& a, pair<set<int>, set<int>>& b, map<pair<set<int>, set<int>>, bool>& dp, int s, vector<int>& sx, vector<int>& sy, int prsum){
    vector<int> x, y;
    auto b1 = b;
    while(!b1.first.empty()){
        x.push_back(*b1.first.begin());
        b1.first.erase(*b1.first.begin());
    }
    while(!b1.second.empty()){
        y.push_back(*b1.second.begin());
        b1.second.erase(*b1.second.begin());
    }
    int sum = prsum;
    for(int i = 0; i < x.size(); i++){
        for (int j = 0; j < y.size(); j++){
            sum += a[x[i]][y[j]];
        }
    }
    dp[b] = true;
    if (sum == s){
        return b;
    }
    if (sum < s){
        set<int> r;
        r.insert(-1);
        return {r, r};
    }
    for (int i = 0; i < a.size(); i++){
        auto c = b;
        c.first.insert(i);
        if (!dp[c]){
            auto r = f(a, c, dp, s, sx, sy, prsum - sx[i]);
            if (*r.first.begin() != -1){
                return r;
            }
        }
    }
    for (int i = 0; i < a[0].size(); i++){
        auto c = b;
        c.second.insert(i);
        if (!dp[c]){
            auto r = f(a, c, dp, s, sx, sy, prsum - sy[i]);
            if (*r.first.begin() != -1){
                return r;
            }
        }
    }
    set<int> r;
    r.insert(-1);
    return {r, r};
}

signed main() {
    int h, w;
    cin >> h >> w;
    vector<vector<int>> a(h, vector<int> (w));
    int sum = 0;
    for (int i = 0; i < h; i++){
        for (int j = 0; j < w; j++){
            cin >> a[i][j];
            sum += a[i][j];
        }
    }
    int s;
    cin >> s;
    vector<int> sx(h), sy(w);
    for (int i = 0; i < h; i++){
        for (int j = 0; j < w; j++){
            sx[i] += a[i][j];
            sy[j] += a[i][j];
        }
    }
    map<pair<set<int>, set<int>>, bool> used;
    set<int> start;
    used[{start, start}] = true;
    pair<set<int>, set<int>> b = {start, start};
    auto r = f(a, b, used, s, sx, sy, sum);
    if (*r.first.begin() == -1){
        cout << "NO";
        return 0;
    }
    cout << "YES\n";
    vector<int> x, y;
    while(!r.first.empty()){
        x.push_back(*r.first.begin());
        r.first.erase(*r.first.begin());
    }
    while(!r.second.empty()) {
        y.push_back(*r.second.begin());
        r.second.erase(*r.second.begin());
    }
    cout << x.size() + y.size() << endl;
    for (int i = 0; i < x.size(); i++){
        cout << 1 << ' ' << x[i] + 1 << endl;
    }
    for (int i = 0; i < y.size(); i++){
        cout << 2 << ' ' << y[i] + 1 << endl;
    }
}