#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define int long long
#define double long double

using namespace std;

signed main() {
    int n;
    cin >> n;
    vector<bool> a(1e6 + 1, false), p(1e6 + 1, true), used(1e6 + 1, false);
    p[1] = false;
    for (int i = 2; i <= 1e6; i++){
        if (p[i]){
            for (int j = i * 2; j <= 1e6; j += i){
                p[j] = false;
            }
        }
    }
    set<int> m;
    vector<int> c(n);
    for (int i = 0; i < n; i++){
        cin >> c[i];
        m.insert(c[i]);
    }
    while(!m.empty()){
        int v = *m.begin();
        for (int i = v * 2; i <= 1e6; i += v){
            if (a[v]){
                continue;
            }
            if (p[i / v]){
                a[i] = true;
            }
        }
        m.erase(v);
    }
    for (int i = 0; i < n; i++){
        if (a[c[i]]){
            cout << 2;
        }
        else{
            cout << 1;
        }
        cout << ' ';
    }
}
