#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define int long long
#define double long double

using namespace std;

int power(int a, int b){
    if (!b){
        return 1;
    }
    if (b % 2){
        return power(a, b - 1) * a;
    }
    int x = power(a, b / 2);
    return x * x;
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), t(n);
    int mn = 1e18;
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    for (int i = 0; i < n; i++){
        cin >> t[i];
        mn = min(mn, a[i] + t[i]);
    }
    int tl = -1, tr = mn + 35;
    while(tr - tl > 1){
        int tm = tl + (tr - tl) / 2;
        int ans = 0;
        for (int i = 0; i < n; i++){
            if (a[i] > tm){
                continue;
            }
            if (a[i] <= tm && a[i] + t[i] > tm){
                ans += 1;
                continue;
            }
            int pow = tm - (a[i] + t[i]) + 1;
            if (pow >= 35){
                ans = 1e18;
                break;
            }
            ans += power(2, pow);
            if (ans > m){
                break;
            }
        }
        if (ans >= m){
            tr = tm;
        }
        else{
            tl = tm;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++){
        if (a[i] > tr){
            continue;
        }
        if (a[i] <= tr && a[i] + t[i] > tr){
            ans += 1;
            continue;
        }
        int pow = tr - (a[i] + t[i]) + 1;
        ans += power(2, pow);
    }
    if (ans == m){
        cout << tr;
    }
    else{
        cout << -1;
    }
}
