#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define int long long
#define double long double

using namespace std;

void dfs(int v, vector<vector<int>>& g, vector<int>& a, vector<int>& s, vector<int>& ind){
    if (a[v] == -1){
        s.push_back(v);
        ind[v] = s.size();
    }
    if (g[v][0] != -1){
        dfs(g[v][0], g, a, s, ind);
    }
    if (a[v] == 0){
        s.push_back(v);
        ind[v] = s.size();
    }
    if (g[v][1] != -1){
        dfs(g[v][1], g, a, s, ind);
    }
    if (a[v] == 1){
        s.push_back(v);
        ind[v] = s.size();
    }
}

signed main() {
    int n, q;
    cin >> n >> q;
    vector<vector<int>> g(n, vector<int>(2));
    vector<int> a(n, -1);
    for(int i = 0; i < n; i++){
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        g[i] = {l, r};
    }
    vector<int> s;
    vector<int> ind(n, -1);
    dfs(0, g, a, s, ind);
    bool f = true;
    while(q--){
        int t;
        cin >> t;
        if (t == 1){
            int l, r, x;
            cin >> l >> r >> x;
            l--;
            r--;
            for (int i = l; i <= r; i++){
                a[i] = x;
            }
            f = false;
        }
        if (t == 2){
            int i;
            cin >> i;
            i--;
            if (f){
                cout << ind[i] << endl;
            }
            else{
                s.resize(0);
                dfs(0, g, a, s, ind);
                f = true;
                cout << ind[i] << endl;
            }
        }
    }
}